#ifndef FACETTE_H
#define FACETTE_H

//
// Chaque facette est incopiable parce qu'elle doit tre
// prise en charge par un serveur de facettes.
//
// Idee de base: au minimum, une facette est comparable
// et possde un attribut de classe nomme (par tradition)
// id. Cet attribut aura une valeur distincte pour chaque
// type de facette. Nous assurons cette caracteristique
//  travers le constructeur de Facette::id
//
// Notez que Facette n'a pas de id, mais que ses enfants,
// eux, devront en avoir un.
//
struct Facette {
   class id {
      static inline long cur{};
      long val;
   public :
      id() : val{ cur++ } {
      }
      bool operator<(const id &autre) const noexcept {
         return val < autre.val;
      }
   };
   virtual ~Facette() = default;
   Facette() = default;
   Facette(const Facette&) = delete;
   Facette& operator=(const Facette&) = delete;
};

#endif
