#ifndef GESTIONNAIRE_TACHES_H
#define GESTIONNAIRE_TACHES_H

#include "Tache.h"
#include "SequenceTaches.h"
#include "Utilitaires.h"
#include "FacettesSysteme.h"
#include "FacetteRythme.h"

#include <iosfwd>

//
// Coteux
//
#include "Etat.h"

//
// Gestionnaire de taches
//
class GestionnaireTaches {
   enum { PROFONDEUR_MIN = 0, PROFONDEUR_MAX = 3 };
   SequenceTaches racine{ 0 };
   GestionnaireTaches();
   static GestionnaireTaches singleton;
   bool entreprendre_deces{ false };
public:
   GestionnaireTaches(const GestionnaireTaches&) = delete;
   GestionnaireTaches& operator=(const GestionnaireTaches&) = delete;
   template <class F>
      void ajouter(F f, int profondeur) {
         racine.ajouter(f, profondeur);
      }
   static GestionnaireTaches &get() {
      static GestionnaireTaches singleton;
      return singleton;
   }
   void executer() {
      if (auto &rythme = utiliser_facette<FacetteRythme>(FacettesSysteme::get());
          !racine.executer(rythme.temps_iteration()))
         ++EtatGlobal.etats_executif.n_debordements_temps_alloue;
      ++EtatGlobal.etats_executif.cpt_it_systeme;
   }
   void terminer() noexcept {
      entreprendre_deces = true;
   }
   bool fin_demandee() const noexcept {
      return entreprendre_deces;
   }
   void afficher_stats(std::ostream &);
};

#endif
