#ifndef UTILITAIRES_H
#define UTILITAIRES_H

template <class T>
   constexpr bool est_entre_inclusif (T val, T minval, T maxval) {
      return minval <= val && val <= maxval;
   }
template <class T>
   constexpr bool est_entre_exclusif (T val, T minval, T maxval) {
      return minval < val && val < maxval;
   }
template <class T>
   constexpr T prochain_circulaire(T cur, T minval, T maxval) {
      return cur == maxval? minval : cur + 1;
   }

template <class F>
void n_times(unsigned long long n, F && f) {
   for (unsigned long long i = 0; i != n; ++i) f();
}
inline auto operator "" _times(unsigned long long n) {
   return [n](auto && f) { for (auto i = 0ULL; i != n; ++i) f(); };
}

#include <iosfwd>
void afficher_stats(std::ostream &);

#endif
